package
{

    import example.ExampleLoaderFactory;

    import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
    import flash.events.Event;

    import nq.net.assets.AssetManager;
    import nq.net.assets.AssetManagerEvent;
    import nq.net.assets.IAssetManager;

    public class Main extends Sprite
    {

        private var _url:String;
        private var _manager:IAssetManager;

        public function Main()
        {
            super();
            super.addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
        }

        private function onAddedToStage(event:Event):void
        {
            super.removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);

            super.stage.align = StageAlign.TOP_LEFT;
            super.stage.scaleMode = StageScaleMode.NO_SCALE;

            // создаем фабрику, которая будет выбирать для нас
            // загрузчик исходя из переданного MIME-типа
            var factory = new ExampleLoaderFactory();

            // создаем мэнеджер ассетов. Он будет загружать
            // и хранить все наши ассеты. Передаем ему фабрику.
            _manager = new AssetManager(factory);

            // далее - пример работы с мэнеджером
            // именно такой подход рекомендуется к использованию

            // объявим переменную с URL-адресом для загрузки
            _url = "http://google.ru/";

            // проверим, не загружали ли мы ее ранее
            if (_manager.hasAsset(_url))
            {
                // нет, ну вообще мы вряд ли уже загружали что-то
                // давайте посмотрим в блок else
            }
            else
            {
                _manager.addEventListener(AssetManagerEvent.ASSET_LOADED, onAssetLoaded);
                _manager.addEventListener(AssetManagerEvent.ASSET_FAILED, onAssetFailed);

                // начнем загрузку
                // по-умолчанию выбирается MIME-тип application/octet-stream
                // по счастливой случайности, наша фабрика умеет отдавать нужный
                // загрузчик для этого типа
                // если бы MIME-тип был другим, мы бы указали его вот так:
                // _manager.load(_url, "image/png");
                _manager.load(_url);
            }
        }

        private function onAssetLoaded(event:AssetManagerEvent):void
        {
            // теперь мы уверены, что все загружено
            trace("Ассет загружен успешно: " + _manager.hasAsset(_url));

            // выведем то, что загрузили
            trace(_manager.getAsset(_url));
        }

        private function onAssetFailed(event:AssetManagerEvent):void
        {
            trace("Произошла ошибка!");
        }
    }
}