package nq.net.assets {

    import flash.events.IEventDispatcher;

    import nq.net.assets.storage.IAssetBundle;

    /**
     * Событие добавления нового ресурса
     */
    [Event(name = "added", type = "flash.events.Event")]

    /**
     * Событие удаления ресурса
     */
    [Event(name = "removed", type = "flash.events.Event")]

    /**
     * Интерфейс для менеджера ресурсов
     */
    public interface IAssetManager extends IAssetBundle, IEventDispatcher {

        /**
         * Добавить ресурс к списку загружаемых
         *
         * @param url       URL-адрес ресурса для загрузки
         * @param mimeType  MIME-тип ресурса для загрузки
         * @param priority  Приоритет загрузки ресурса
         */
        function load(url:String, mimeType:String = "application/octet-stream" /* nq.net.MIMEType.OCTET_STREAM */, priority:int = 0):void;

    }

}
